# Contribution Guidelines

- If you think you've found a security vulnerability, please email
  delfin@avery.cafe

## Bug Reports and Feature Requests

You can report bugs or file feature requests on the
[issue tracker](https://codeberg.org/avery42/delfin).

- Before creating an issue, do a quick search to check if the issue has already
  been reported.
- When creating an issue,
  please choose the appropriate template, and follow it to the best of your
  ability.
  - Following the templates helps to ensure that you include the relevant
    information in your issue, and reduces back and forth.

## Development

See [Development Setup](https://codeberg.org/avery42/delfin#development-setup).

Before working on a change or new feature, please open an issue for discussion.
At this stage, Delfin aims to provide a cohesive UI for the most important
features. Before implementation, there should be a discussion about how a new
feature will fit into the app, along with whether the feature even belongs in
the first place.

## Translations

Contributions to translations are welcome on
[Weblate](https://translate.codeberg.org/projects/delfin/).

Delfin's translations are using the
[Fluent localization system](https://projectfluent.org/). A syntax guide is
availble [here](https://projectfluent.org/fluent/guide/).

<a href="https://translate.codeberg.org/engage/delfin/">
    <img src="https://translate.codeberg.org/widget/delfin/open-graph.png" alt="Translation status" width="400px" />
</a>

<br />
<a href="https://translate.codeberg.org/engage/delfin/">
    <img src="https://translate.codeberg.org/widget/delfin/multi-auto.svg" alt="Translation status" />
</a>
